#include <intrinsics.h>
#include "AT91SAM7S256.h"
#include "system.h"
#include "adc.h"

#define LONG     5000000
#define SHORT    1000000

//#define LONG     900000
//#define SHORT    100000

//MAIN POINTER
AT91PS_PIO    m_pPio   = AT91C_BASE_PIOA;
AT91PS_PMC    m_pPMC   = AT91C_BASE_PMC;
AT91PS_USART  m_pUSART = AT91C_BASE_US0;
AT91PS_PDC    m_pPDC   = AT91C_BASE_PDC_US0;
AT91PS_MC     m_pMC    = AT91C_BASE_MC;
AT91PS_AIC    m_pAic   = AT91C_BASE_AIC;
AT91PS_SYS    m_pSys   = AT91C_BASE_SYS;
AT91PS_ADC    m_pADC   = AT91C_BASE_ADC;
AT91PS_RSTC   m_pRSTC  = AT91C_BASE_RSTC;

//it's a simple delay
void Delay (unsigned long a) { while (--a!=0); }


unsigned int i = 0;


int main()
{
  __disable_interrupt();

  // System init
  //InitFrec();

  // Init perifery
  InitPeriphery();

//Enable RESET
  m_pRSTC->RSTC_RCR = 0xA5000008;
  m_pRSTC->RSTC_RMR = 0xA5000001;


  //enable the clock of the PIO
  m_pPMC->PMC_PCER = 1 << AT91C_ID_PIOA;
  Delay(100000);

  // Configure led
  m_pPio->PIO_SODR  = BIT8;   // Set PA8 to HIGH -> led off
  m_pPio->PIO_OER   = BIT8;   // Configure PA8 as output

  while(1)
  {
    m_pPio->PIO_CODR = BIT8;   // Set PA8 to LOW -> led on
    Delay(800000);
    m_pPio->PIO_SODR = BIT8;   // Set PA8 to HIGH -> led off
    Delay(800000);
  }
}


